// SceneView.h : CSceneView NX̃C^[tFCX
//


#pragma once

#define	WM_USER_RENDER_SCENE	(WM_USER + 1)

#include "Figure.h"
#include "MotionData.h"
#include "Vector.h"

class CSceneView : public CView
{
protected: // VÂݍ쐬܂B
	CSceneView();
	DECLARE_DYNCREATE(CSceneView)

// 
public:
	CMainDoc* GetDocument() const;

// 
public:

// I[o[Ch
public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CSceneView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	LPDIRECT3D9 m_pD3D;
	LPDIRECT3DDEVICE9 m_pDeviceD3D;

protected:
	LPD3DXEFFECT m_pEffect;
	D3DXHANDLE m_hTechPhong;

	D3DXHANDLE m_hWorld;
	D3DXHANDLE m_hWorldIT;
	D3DXHANDLE m_hWorldViewProj;
	D3DXHANDLE m_hEyePos;

protected:
	D3DXMATRIX m_mProjection;
	D3DXMATRIX m_mView;
	D3DXVECTOR3 m_pvView[3];
	D3DXMATRIX m_pmViewTrans[3];
	POINT m_pntDown;

	LPD3DXMESH m_pMeshSphere;
	CFigure	*m_pFigure[3];		// 0: gC1: 㔼gC2: ڑ
	CMotionData *m_pMotion[3];
	size_t m_frame;
	bool m_bPlay;

protected:
	HRESULT InitDirectGraphics(void);
	HRESULT InitRenderState(void);
	HRESULT InitHLSL(void);
	HRESULT DrawMeshSub(const LPD3DXMESH pMesh, const D3DXMATRIX &mWorld) const;

protected:
	void DrawSkeletonSub(const CJoint *pJoint, LPD3DXMATRIXSTACK &pMatStack);
	void DrawSkeleton(size_t id);

protected:
	DECLARE_MESSAGE_MAP()
	afx_msg LRESULT OnRenderScene(WPARAM wPara, LPARAM lPara);
	virtual void OnInitialUpdate();
	afx_msg void OnDestroy();
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnFileOpen();
	afx_msg void OnFilePlay();
	afx_msg void OnUpdateFilePlay(CCmdUI *pCmdUI);
	afx_msg void OnFileSaveAs();
	afx_msg void OnMotionTemporalAlign();
	afx_msg void OnMotionSpatialAlign();
	afx_msg void OnMotionSplicing();
	afx_msg void OnMotionTransfer();
};

#ifndef _DEBUG  // SceneView.cpp ̃fobO o[W
inline CMainDoc* CSceneView::GetDocument() const
   { return reinterpret_cast<CMainDoc*>(m_pDocument); }
#endif

