/**
 * @file Statistics.h
 * @brief v͊֐QOԐ錾
 * @author cherub
 */
#ifndef STATISTICS_NAMESPACE_HEADER_FILE_
#define STATISTICS_NAMESPACE_HEADER_FILE_

#include "Vector.h"
#include "Matrix.h"

/**
 * @namespace NStatistics Statistics.h
 * @brief v͊֐QO
 * @author cherub
 */
namespace NStatistics
{
	// ŗLl
	bool EVD(CMatrix &evecs, CVector &evals, const CMatrix &data);
	// GRm~[TCYْ̓l
	bool SVD(CMatrix &u, CVector &s, CMatrix &v, const CMatrix &data);
	// 听
	bool PCA(CMatrix &scores, CMatrix &rot, CVector &cont, CVector &mean, const CMatrix &data);
};

#endif //STATISTICS_NAMESPACE_HEADER_FILE_
